# -*- coding: utf-8 -*- 
'''
Praktikum 12, lahendused.
Viimati uuendatud 17.11.2024.
'''
#%% ül 1.

class DoorBell:
    
    click = 0  # Staatiline klassimuutuja.
    
    def __init__(self):
        self.click = 0  # Dünaamiline objektimuutuja.
        
    def ring(self):
        self.click += 1
        DoorBell.click += 1
        print(f"Ring! -> Counters: dynamic {self.click}, static {DoorBell.click}.")


d1 = DoorBell()
d2 = DoorBell()

for _ in range(5):
    d1.ring()
    
for _ in range(2):
    d2.ring()

print(d1.click)
print(d2.click)
print(DoorBell.click)  # Loeb kokku kõik meetodi ring väljakutsed.


#%% ül 2.

class Rahakott:

    def __init__(self, värv, materjal, raha=0, kaardid=0, dokumendid=0):
        self.värv = värv
        self.materjal = materjal
        self.raha = raha
        self.kaardid = kaardid
        self.dokumendid = dokumendid
        

r1 = Rahakott('punane', 'nahk', 200)
r2 = Rahakott('sinine', 'tekstiil', 2000)

print(r1)
print(r1.värv)
print(r1.materjal)
print(r1.raha)

print()
print(r2)
print(r2.värv)
print(r2.materjal)
print(r2.raha)


#%% ül 3.

class Rahakott:

    def __init__(self, värv, materjal, raha=0, kaardid=0, dokumendid=0):
        self.värv = värv
        self.materjal = materjal
        self.raha = raha
        self.kaardid = kaardid
        self.dokumendid = dokumendid
        
    def lisa(self, uus_raha):
        self.raha += uus_raha
        return self.raha
    
    def võta(self, miinus_raha):
        self.raha -= miinus_raha
        return self.raha
        

r1 = Rahakott('punane', 'nahk', 0)

r1.lisa(300)
print(r1.raha)

r1.võta(300)
print(r1.raha)


#%% ül 4.

class Rahakott:

    def __init__(self, värv, materjal, raha=0, kaardid=0, dokumendid=0):
        self.värv = värv
        self.materjal = materjal
        self.raha = raha
        self.kaardid = kaardid
        self.dokumendid = dokumendid
        
    def __str__(self):  # Kirjutan olemasoleva üle.
        return '{} {}st rahakott sisaldab {} eurot, {}\
 pangakaarti ja {} dokumenti.'.format(self.värv.capitalize(), 
                                    self.materjal, 
                                    self.raha,
                                    self.kaardid,
                                    self.dokumendid)
    
    def __repr__(self):  # Kirjutan olemasoleva üle.
        return '{} {}st rahakott sisaldab {} eurot, {}\
 pangakaarti ja {} dokumenti.'.format(self.värv.capitalize(), 
                                    self.materjal, 
                                    self.raha,
                                    self.kaardid,
                                    self.dokumendid)
        

r1 = Rahakott('punane', 'nahk', 200, 2, 5)

print(r1)
print(str(r1))
print(r1.__str__())

print()
print(repr(r1))
print(r1.__repr__())


#%% ül 5.

class MyInt:

    def __init__(self, vaartus):
        self.vaartus = vaartus
        
    def add(self, other):
        return self.vaartus + other.vaartus  # Andmetüüp muutub MyInt --> int.
    

num1 = MyInt(1)
num2 = MyInt(3)

print(num1.add(num2))
print(MyInt.add(num1, num2))

print(MyInt(1).add(num2))      # Nii töötab ka.
print(MyInt(1).add(MyInt(3)))  # Nii töötab ka.


#%% ül 5, teine lahend.

class MyInt:

    def __init__(self, vaartus):
        self.vaartus = vaartus
        
    def add(self, other):
        summa = self.vaartus + other.vaartus
        return MyInt(summa)  # type(self)(summa)  # Andmetüüp jääb samaks MyInt.

    def __str__(self):  # Esitus sõnena konsoolis ja mujal.
        return f'{self.vaartus}'
    
    def __repr__(self):  # Meetodile vastab funtsioon repr.
        return f'{self.vaartus}'
    

num1 = MyInt(1)
num2 = MyInt(3)

print(num1.add(num2))
print(MyInt.add(num1, num2))

print(MyInt(1).add(num2))      # Nii töötab ka.
print(MyInt(1).add(MyInt(3)))  # Nii töötab ka.


# Üleval olev kood garanteerib, et saame meetodit add rakendada mitu korda järjest.
print(num1.add(num2).add(num2))


#%% ül 6.

class MyInt:

    def __init__(self, vaartus):
        self.vaartus = vaartus
        
    def __mul__(self, other):
        return self.vaartus * other.vaartus  # Väljastatud andmetüüp on int.
    

num1 = MyInt(2)
num2 = MyInt(3)

print(num1 * num2)
print(num1.__mul__(num2))
print(MyInt.__mul__(num1, num2))

print(MyInt(2) * MyInt(3))    # Nii töötab ka.
print(MyInt(2).__mul__(num2))  # Nii töötab ka.


#%% ül 6, teine lahendus.

class MyInt:

    def __init__(self, vaartus):
        self.vaartus = vaartus
        
    def __mul__(self, other):
        prod = self.vaartus * other.vaartus
        return MyInt(prod)  # type(self)(prod)

    def __str__(self):  # Esitus sõnena konsoolis ja mujal.
        return f'{self.vaartus}'
    
    def __repr__(self):  # Meetodile vastab funtsioon repr.
        return f'{self.vaartus}'
    

n1 = MyInt(2)
n2 = MyInt(3)

print(n1 * n2)
print(n1.__mul__(n2))
print(MyInt.__mul__(n1, n2))

print(MyInt(2) * MyInt(3))   # Nii töötab ka.
print(MyInt(2).__mul__(n2))  # Nii töötab ka.

# Üleval olev kood garanteerib et saame * rakendada mitu korda järjest.
print(n1 * n2 * n2)


#%% ül 7.

class Punkt:

    def __init__(self, x, y, z):
        self.x = x
        self.y = y
        self.z = z

    def __eq__(self, other):
        if isinstance(other, Punkt):
            tulem = self.x == other.x and self.y == other.y and self.z == other.z  
            return tulem
        return False


p1 = Punkt(1, 2, 3)
p2 = Punkt(1, 2, 3)

print(p1 == p2)
print(p1.__eq__(p2))
print(Punkt.__eq__(p1, p2))

# Rakendame operaatorit mitu korda järjest.
print(p1 == p2 == p2)


#%% ül 8.

class Punkt:

    def __init__(self, x, y, z):
        self.x = x
        self.y = y
        self.z = z

    def __eq__(self, other):
        if isinstance(other, Punkt):
            tulem = self.x == other.x and self.y == other.y and self.z == other.z  
            return tulem
        return False
        
    def __gt__(self, other):
        if isinstance(other, Punkt):
            b = self.x >= other.x and self.y >= other.y and self.z >= other.z
            return b
        return False

    def __lt__(self, other):
        if isinstance(other, Punkt):
            b = self.x <= other.x and self.y <= other.y and self.z <= other.z
            return b
        return False


p1 = Punkt(1, 2, 3)
p2 = Punkt(1, 2, 3.1)

print(p1 < p2)
print(p1.__lt__(p2))
print(Punkt.__lt__(p1, p2))

print()
print(p1 > p2)
print(p1.__gt__(p2))
print(Punkt.__gt__(p1, p2))


#%% ül 9.

class AinePaevik:
    
    def __init__(self, nimi_opilane=''):
        self.nimi_opilane = nimi_opilane
        self.hinded = []
        
    def prindi_hinded(self):  # Getter.
        if len(self.hinded) == 0:  # Listi pikkus.
            print('Hinded puuduvad.')
        else:
            print(self.hinded)  # Prindib listi.

    def lisa_hinne(self, hinne):  # Setter.
        self.hinded.append(hinne)
        print(f'{self.nimi_opilane}: Hinne "{hinne}" on LISATUD.')

    def eemalda_hinne_indeksiga(self, index=-1):
        eemaldatud_hinne = self.hinded.pop(index)
        print(f'{self.nimi_opilane}: Hinne "{eemaldatud_hinne}" on EEMALDATUD.')


juulius = AinePaevik('Juulius Tipikas')

juulius.prindi_hinded()

print()
juulius.lisa_hinne(1)
juulius.lisa_hinne(5)
juulius.lisa_hinne(3)
juulius.prindi_hinded()

print()
juulius.eemalda_hinne_indeksiga(0)  # Vaikimisi indeks eemaldab viimase.
juulius.prindi_hinded()


#%% ül 10*.

class OpetajaPaevik:
    
    def __init__(self, nimi_opilane='', ained=[]):
        self.nimi_opilane = nimi_opilane
        self.ained = ained
        self.hinded = {}
        for aine in ained:
            self.hinded[aine] = []
        
    def prindi_hinded(self):  # Getter.
        if len(self.hinded) == 0:  # Sõnaraamatu võtmete arv.
            print('Ained pole deklareeritud.')
        else:
            print(self.hinded)  # Prindib sõnaraamatu.

    def lisa_aines_hinne(self, aine, hinne):  # Setter.
        if aine in self.ained:
            self.hinded[aine].append(hinne)
            print(f'{self.nimi_opilane}: Hinne "{hinne}" aines {aine} LISATUD.')
        else:
            print(f'VIGA: {self.nimi_opilane} pole ainet {aine} võtnud.')

    def eemalda_aines_hinne_indeksiga(self, aine, index=-1):
        if aine in self.ained:
            eemaldatud_hinne = self.hinded[aine].pop(index)
            print(f'{self.nimi_opilane}: Hinne "{eemaldatud_hinne}" aines {aine} EEMALDATUD.')
        else:
            print(f'VIGA: {self.nimi_opilane} pole ainet {aine} võtnud.')


juuliuse_ained = ['Mata', 'Kehaline']
juulius = OpetajaPaevik('Juulius Tipikas', juuliuse_ained)

juulius.prindi_hinded()

print()
juulius.lisa_aines_hinne('Mata', 1)
juulius.lisa_aines_hinne('Mata', 5)
juulius.lisa_aines_hinne('Mata', 3)
juulius.prindi_hinded()

print()
juulius.eemalda_aines_hinne_indeksiga('Mata', 0)  # Vaikimisi indeks eemaldab viimase.
juulius.prindi_hinded()


#%% ül 11.

class Vektor:

    def __init__(self, x_comp, y_comp):
        self.x_comp = x_comp
        self.y_comp = y_comp

    def __abs__(self):
        return (self.x_comp**2 + self.y_comp**2)**0.5


vektor = Vektor(3, 4)

print(abs(vektor))
print(vektor.__abs__())
print(Vektor(3, 4).__abs__())

print(abs(Vektor(3, 4)))  # Nii saab ka.


#%% ül 11 b.
import math

class Vektor:

    def __init__(self, x_comp, y_comp):
        self.x_comp = x_comp
        self.y_comp = y_comp

    def __abs__(self):
        return math.sqrt(self.x_comp**2 + self.y_comp**2)


vektor = Vektor(3, 4)

print(abs(vektor))
print(vektor.__abs__())
print(Vektor(3, 4).__abs__())

print(abs(Vektor(3, 4)))  # Nii saab ka.


#%% ül 12.

class Vektor:

    def __init__(self, x, y):
        self.x = x
        self.y = y
    
    def __add__(self, other):
        x_comp = self.x + other.x
        y_comp = self.y + other.y
        return (x_comp**2 + y_comp**2)**0.5


vektor1 = Vektor(3, 4)
vektor2 = Vektor(1, 1)

print(vektor1 + vektor2)

print(vektor1.__add__(vektor2))          # Nii saab ka.
print(Vektor.__add__(vektor1, vektor2))  # Nii saab ka.
print(Vektor(3, 4) + Vektor(1, 1))       # Nii saab ka.



#%% ül 12 b.
import math

class Vektor:

    def __init__(self, x, y):
        self.x = x
        self.y = y
    
    def __add__(self, other):
        x_comp = self.x + other.x
        y_comp = self.y + other.y
        return math.sqrt(x_comp**2 + y_comp**2)


vektor1 = Vektor(3, 4)
vektor2 = Vektor(1, 1)

print(vektor1 + vektor2)

print(vektor1.__add__(vektor2))          # Nii saab ka.
print(Vektor.__add__(vektor1, vektor2))  # Nii saab ka.
print(Vektor(3, 4) + Vektor(1, 1))       # Nii saab ka.


#%% ül 13.

class Vektor:

    def __init__(self, x, y):
        self.x = x
        self.y = y
    
    def __add__(self, other):
        sl = (self.x**2 + self.y**2)**0.5
        ol = (other.x**2 + other.y**2)**0.5
        return sl + ol


vektor1 = Vektor(3, 4)
vektor2 = Vektor(1, 1)

print(vektor1 + vektor2)

print(vektor1.__add__(vektor2))          # Nii saab ka.
print(Vektor.__add__(vektor1, vektor2))  # Nii saab ka.
print(Vektor(3, 4) + Vektor(1, 1))       # Nii saab ka.


#%% ül 13, teine lahend.

class Vektor:

    def __init__(self, x, y):
        self.x = x
        self.y = y
        
    def pikkus(self):  # saab ka __abs__ olla
        return (self.x**2 + self.y**2)**0.5
    
    def __add__(self, other):
        return self.pikkus() + other.pikkus()


vektor1 = Vektor(3, 4)
vektor2 = Vektor(1, 1)

print(vektor1 + vektor2)

print(vektor1.__add__(vektor2))          # Nii saab ka.
print(Vektor.__add__(vektor1, vektor2))  # Nii saab ka.
print(Vektor(3, 4) + Vektor(1, 1))       # Nii saab ka.


#%% ül 13, kolmas lahend.

class Vektor:

    def __init__(self, x, y):
        self.x = x
        self.y = y
        
    def __abs__(self):
        return (self.x**2 + self.y**2)**0.5
    
    def __add__(self, other):
        return self.__abs__() + other.__abs__()


vektor1 = Vektor(3, 4)
vektor2 = Vektor(1, 1)

print(vektor1 + vektor2)

print(vektor1.__add__(vektor2))          # Nii saab ka.
print(Vektor.__add__(vektor1, vektor2))  # Nii saab ka.
print(Vektor(3, 4) + Vektor(1, 1))       # Nii saab ka.


#%% ül 14.

class Iteraator:

    def __init__(self):  # Pole argumente.
        self.num = -1
        
    def __iter__(self):
        return self
    
    def __next__(self):
        self.num += 1
        return self.num
    

number = Iteraator()  # Number, iteraatortoega objekt.

print(next(number))
print(next(number))
print(next(number))
    
for i in number:
    if i > 10:
        break
    print(i)
    
print()

for i in Iteraator():
    if i > 10:
        break
    print(i)


#%% ül 14, teine lahend.

class Iteraator:

    def __init__(self):  # Pole argumente.
        self.num = 0
        
    def __iter__(self):
        return self
    
    def __next__(self):
        tulem = self.num
        self.num += 1
        return tulem

    
number = Iteraator()  # Number, iteraatortoega objekt.

print(next(number))
print(next(number))
print(next(number))
    
for i in number:
    if i > 10:
        break
    print(i)
    
print()

for i in Iteraator():
    if i > 10:
        break
    print(i)


#%% ül 15.

class Bank:

    def __init__(self, name, balance):
        """Creates new bank card."""
        self.name = name
        self._balance = balance

    def get_balance(self):
        return self._balance

    def deposit(self, amount):
        """
        Deposit money to bank account.
        Deposit can be made if amount is not negative.
        """
        if amount < 0:
            return False
        self._balance += amount
        return True

    def withdraw(self, amount):
        """
        Withdraw money from bank account.
        Withdraw can't be made if amount is negative or
        withdrawal would end with negative balance.
        """
        if amount < 0 or self._balance - amount < 0:
            return False
        self._balance -= amount
        return True


konto = Bank('Juulius', 500)

print(konto.get_balance())
print(konto.deposit(300))
print(konto.get_balance())
print(konto.withdraw(300))
print(konto.get_balance())
print(konto.withdraw(1500))  # Ei õnnestu.
print(konto.get_balance())


#%% ül 15, teine lahend.
#Lisan argumendi tüübid ja oodatav väljundi tüübi (pole vaja).
#Loengus pole me sellist võimalust maininud.

class Bank:

    def __init__(self, name: str, balance: int):
        """Creates new bank card."""
        self.name = name
        self._balance = balance

    def get_balance(self):
        return self._balance

    def deposit(self, amount: int) -> bool:
        """
        Deposit money to bank account.
        Deposit can be made if amount is not negative.
        """
        if amount < 0:
            return False
        self._balance += amount
        return True

    def withdraw(self, amount: int) -> bool:
        """
        Withdraw money from bank account.
        Withdraw can't be made if amount is negative or
        withdrawal would end with negative balance.
        """
        if amount < 0 or self._balance - amount < 0:
            return False
        self._balance -= amount
        return True


konto = Bank('Juulius', 500)

print(konto.get_balance())


#%% ül 16.

class Iteraator:

    def __init__(self):
        self.num = -1
        
    def __iter__(self):
        return self
    
    def __next__(self):
        if self.num <= 9:
            self.num += 1
            return self.num
        else:
            raise StopIteration('Sõnum siia.')
            

number = Iteraator()

for i in number:
    print(i)
    
next(number)  # Tõstatab erisuse, OK.


#%% ül 16, teine lahend.

class Iteraator:

    def __init__(self):
        self.num = 0
        
    def __iter__(self):
        return self
    
    def __next__(self):
        if self.num <= 10:
            tulem = self.num
            self.num += 1
            return tulem
        else:
            raise StopIteration('Sõnum siia.')
            

number = Iteraator()

for i in number:
    print(i)
    
next(number)  # Tõstatab erisuse.


#%% ül 17.

class Iteraator:

    def __init__(self, algus, lopp, samm):
        self.num = algus
        self.lopp = lopp 
        self.samm = samm 
        
    def __iter__(self):
        return self
    
    def __next__(self):  # See pole hea lahendus aga teeb mida küsitakse.
        if abs(self.num) <= abs(self.lopp):  # Funktsioon abs, negatiivse jaoks.
            tulem = self.num
            self.num += self.samm
            return tulem
        else:
            raise StopIteration
            

numbrid1 = Iteraator(0, 20, 2)
numbrid2 = Iteraator(0, -10, -1)

for i in numbrid1:
    print(i)

print()

for i in numbrid2:
    print(i)
    

#%% ül 18*.

class MyInt:

    def add(self, arv1, arv2):  # Muutuja self peab tavaliselt olema.
        return arv1 + arv2


print(MyInt().add(1, 2))

MyInt_obj = MyInt()
print(MyInt_obj.add(1, 2))


#%% ül 18*, b.
# Töötab ka nii aga erinev küsitust, ebatäpne vastus.

class MyInt:

    def add(arv1, arv2):  # Kui ei taha ei initsialiseeri, self puudu.
        return arv1 + arv2
    

print(MyInt.add(1, 2))

MyInt_obj = MyInt
print(MyInt_obj.add(1, 2))























